"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
var plugin_1 = __importDefault(require("./plugin"));
/**
 * 双端组件babel插件
 * 1. import React from 'react' => import React, { suspense, lazy } from 'react'
 * 2. import { useMobile, Button } from '@ad/r-ui' => import { useMobile } from '@ad/r-ui'
 * 3. 组件重新封装
 */
exports["default"] = (0, helper_plugin_utils_1.declare)(function ruiPlugin(babel) {
    var t = babel.types, assertVersion = babel.assertVersion;
    assertVersion(7);
    var globalPlugin = null;
    return {
        name: 'lazy-load',
        visitor: {
            Program: {
                enter: function (path, state) {
                    globalPlugin = new plugin_1["default"](t, state.opts);
                    globalPlugin.bootstrap(path);
                },
                exit: function () {
                    if (!globalPlugin)
                        return;
                    globalPlugin = null;
                }
            }
        }
    };
});
