"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.toKebabCase = exports.mergeOptions = exports.addChunkNameComment = exports.mergeObject = void 0;
var const_1 = require("./const");
/** Merge object, src has higher priority */
function mergeObject(src, base) {
    return Object.keys(base).reduce(function (prev, key) {
        var _a, _b;
        if (!prev[key]) {
            return __assign(__assign({}, prev), (_a = {}, _a[key] = base[key], _a));
        }
        else if (typeof prev[key] === 'object') {
            return __assign(__assign({}, prev), (_b = {}, _b[key] = mergeObject(prev[key], base[key]), _b));
        }
        else {
            return prev;
        }
    }, src);
}
exports.mergeObject = mergeObject;
/** add add leading comment for webpackChunk */
function addChunkNameComment(node, name) {
    // only add leading comment when not found
    if (node.leadingComments)
        return;
    node.leadingComments = [
        {
            type: 'CommentBlock',
            value: " webpackChunkName: '".concat(name, "' ")
        },
    ];
    return node;
}
exports.addChunkNameComment = addChunkNameComment;
var defaultOptions = {
    libraryName: const_1.libraryName,
    libraryDir: {
        pc: function (name) { return "es/components/".concat(name, "/pc"); },
        mobile: function (name) { return "es/components/".concat(name, "/mobile"); }
    },
    chunkNames: {
        pc: 'rui-pc',
        mobile: 'rui-mobile'
    },
    splitChunkByComp: false,
    verbose: false
};
/** get real options */
function mergeOptions(opts) {
    if (opts === void 0) { opts = {}; }
    return mergeObject(opts, defaultOptions);
}
exports.mergeOptions = mergeOptions;
function toKebabCase(str) {
    var KEBAB_REGEX = /[A-Z\u00C0-\u00D6\u00D8-\u00DE]/g;
    return str.replace(KEBAB_REGEX, function (match) { return match.toLowerCase(); });
}
exports.toKebabCase = toKebabCase;
